## cppad 2018.00.00.0

=== CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# =============================================================================
# Some constants
# =============================================================================
# Suppress warnging that WIN32 not defined on cygwin
SET(CMAKE_LEGACY_CYGWIN_WIN32 0) # remove when version below >= 2.8.4
#
# Set the minimum required version of cmake for this project.
# see http://www.cmake.org/pipermail/cmake/2013-January/053213.html
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
#
# https://gitlab.kitware.com/cmake/cmake/issues/17292
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()
#
# cppad_version is used by set_version.sh to get the version number.
SET(cppad_version      "20180000.0" )
SET(cppad_url          "http://www.coin-or.org/CppAD" )
SET(cppad_description  "Differentiation of C++ Algorithms" )
#
# Set name of this project and create the variables
# cppad_BINARY_DIR and cppad_SOURCE_DIR.
# project(projectname [CXX] [C] [Java])
PROJECT(cppad)
#
# Add this directory to the list of C++ preprocessor include directories
# for the entire project.
# include_directories([AFTER|BEFORE] [SYSTEM] dir1 dir2 ...)
INCLUDE_DIRECTORIES( ${cppad_SOURCE_DIR} )
#
# =============================================================================
# Some system cmake language extensions
# =============================================================================
# CHECK_CXX_SOURCE_COMPILES(source variable)
# Checks whether the code given in source will compile, link and run and
# return zero status. You can set
# CMAKE_REQUIRED_LIBRARIES, CMAKE_REQUIRED_FLAGS and CMAKE_REQUIRED_INCLUDES
# accordingly if additional libraries or compiler flags are required.
INCLUDE(CheckCXXSourceRuns)

# ============================================================================
# Some local cmake language
# ============================================================================
# dos_path_to_unix(dos_path unix_path)
INCLUDE(cmake/dos_path_to_unix.cmake)
#
# add_to_list(variable_list constant_value)
INCLUDE(cmake/add_to_list.cmake)
#
# command_line_arg(variable default type description)
INCLUDE(cmake/command_line_arg.cmake)
#
# optional_package(package description)
INCLUDE(cmake/optional_package.cmake)
#
# check_source_runs(source variable)
INCLUDE(cmake/check_source_runs.cmake)
#
# assert(variable)
INCLUDE(cmake/assert.cmake)
#
# print_variable(variable)
INCLUDE(cmake/print_variable.cmake)
#
# set_compile_flags( program_name debug_which source_list)
INCLUDE(cmake/set_compile_flags.cmake)
# =============================================================================
# command line arguments
# =============================================================================
# cmake_install_datadir
command_line_arg(cmake_install_datadir share STRING
	"directory, below prefix, where cmake installs cppad data files"
)
# -----------------------------------------------------------------------------
# cmake_install_docdir
command_line_arg(cmake_install_docdir NOTFOUND STRING
	"directory, below prefix, where cmake installs cppad documentation files"
)
# -----------------------------------------------------------------------------
# cmake_install_includedirs
command_line_arg(cmake_install_includedirs include STRING
	"directories, below prefix, where cmake installs include files"
)
# -----------------------------------------------------------------------------
# cmake_install_libdirs
command_line_arg(cmake_install_libdirs lib STRING
	"directories, below prefix, where cmake installs library files"
)
# -----------------------------------------------------------------------------
# cppad_prefix
command_line_arg(cppad_prefix /usr PATH
	"cppad install prefix"
)
SET(CMAKE_INSTALL_PREFIX "${cppad_prefix}"
	CACHE PATH "value copied from cppad_prefix" FORCE
)
IF( cppad_has_cmake_install )
	MESSAGE(FATAL_ERROR
		"cmake_install_prefix has been changed to cppad_prefix"
	)
ENDIF( cppad_has_cmake_install )
# -----------------------------------------------------------------------------
# cppad_postfix
command_line_arg(cppad_postfix NOTFOUND STRING
	"cppad install postfix"
)
IF( cmake_install_postfix )
	MESSAGE(FATAL_ERROR
		"cmake_install_postfix has been changed to cppad_postfix"
	)
ENDIF( cmake_install_postfix )
# -----------------------------------------------------------------------------
# cppad_cxx_flags
command_line_arg(cppad_cxx_flags "" STRING
	"compile flags used with cppad (besides debug, release, and profile flags)"
)
# -----------------------------------------------------------------------------
# cppad_profile_flag
command_line_arg(cppad_profile_flag NOTFOUND STRING
	"compile flag used to compile and link a profile version of a program"
)
# -----------------------------------------------------------------------------
# External package prefixes with warnings
SET(system_include FALSE)
#
# adolc_prefix
optional_package(adolc ${system_include} "adolc install prefix")
#
# colpack_prefix
optional_package(colpack ${system_include} "colpack install prefix")
#
# ipopt_prefix
optional_package(ipopt ${system_include} "ipopt install prefix")
#
# sacado_prefix
optional_package(sacado ${system_include} "sacado install prefix")
# -----------------------------------------------------------------------------
# External package prefixes without warnings
SET(system_include TRUE)
#
# eigen_prefix
optional_package(eigen ${system_include} "eigen install prefix")
#
# fadbad_prefix
optional_package(fadbad ${system_include} "fadbad install prefix")
# -----------------------------------------------------------------------------
# cppad_testvector
command_line_arg(cppad_testvector cppad STRING
	"Namespace of vector used for testing, one of: boost, cppad, eigen, std"
)
#
# cppad_max_num_threads
command_line_arg(cppad_max_num_threads 48 STRING
	"maximum number of threads that CppAD can use use"
)
# cppad_sparse_list
IF( cppad_sparse_list )
	MESSAGE(FATAL_ERROR
		"cppad_sparse_list = ${cppad_sparse_list}"
		": this command line argument has been removed"
	)
ENDIF( cppad_sparse_list )
#
# cppad_tape_id_type
command_line_arg(cppad_tape_id_type "unsigned int" STRING
	"type used to identify different tapes, size must be <= sizeof(size_t)"
)
#
# cppad_tape_addr_type
command_line_arg(cppad_tape_addr_type "unsigned int" STRING
"type used to identify variables on one tape, size must be <= sizeof(size_t)"
)
#
# cppad_debug_which
command_line_arg(cppad_debug_which "debug_all" STRING
	"debug_even, debug_odd, debug_all, or debug_none"
)
# cppad_deprecated
command_line_arg(cppad_deprecated NO BOOL
	"this symbol must be NO and is not currently being used"
)
IF( cppad_deprecated )
	MESSAGE(FATAL_ERROR "cppad_deprecated must be NO" )
ENDIF( cppad_deprecated )
# =============================================================================
# colpack_libs, cppad_lib
#
IF( cppad_has_colpack )
	SET( colpack_libs "ColPack" )
	SET( cppad_lib    "cppad_lib" )
ELSE( cppad_has_colpack )
	SET( colpack_libs "" )
	SET( cppad_lib    "" )
ENDIF( cppad_has_colpack )
# =============================================================================
# automated system configuration
# =============================================================================
# CMAKE_CXX_FLAGS
# remove Visual Studio C++ warning level if specified in cppad_cxx_flags
IF ( cppad_cxx_flags MATCHES "/W[0-9]" )
	STRING( REGEX REPLACE "/W[0-9]" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS} )
ENDIF ( cppad_cxx_flags MATCHES "/W[0-9]" )
print_variable(CMAKE_CXX_FLAGS)
# -----------------------------------------------------------------------------
# set cppad_abs_${middle_name} for middle_name equal to:
#	includedir, liddir, datadir, docdir
FOREACH(middle_names includedirs libdirs datadir docdir)
	STRING(REGEX REPLACE "dirs" "dir" middle_name ${middle_names})
	SET(middle_value NOTFOUND)
	FOREACH(dir ${cmake_install_${middle_names}})
		IF( NOT middle_value )
			SET(middle_value ${dir})
		ENDIF( NOT middle_value )
	ENDFOREACH(dir ${cmake_install_${middle_names}})
	#
	SET(tmp "${cppad_prefix}/${middle_value}" )
	IF ( cppad_postfix )
		SET(cppad_abs_${middle_name} ${tmp}/${cppad_postfix})
	ELSE ( cppad_postfix )
		SET(cppad_abs_${middle_name} ${tmp})
	ENDIF ( cppad_postfix )
ENDFOREACH(middle_names includedirs libdirs datadir docdir)
# -----------------------------------------------------------------------------
# boost_prefix
FIND_PACKAGE(Boost)
SET(cppad_has_boost 0)
IF ( Boost_FOUND )
	SET(cppad_has_boost 1)
	#
	# Extract the Boost prefix from Boost_INCLUDE_DIRS
	#
	# convert to using unix directory separator
	dos_path_to_unix("${Boost_INCLUDE_DIRS}" boost_include_dirs)
	#
	# convert to just one directory
	STRING(REGEX REPLACE
		"([^ ]+).*" "\\1"
		boost_include_dir "${boost_include_dirs}"
	)
	#
	# extract part before last backslash
	STRING(REGEX REPLACE
		"([^ ]*)/[^/ ]*" "\\1"
		boost_prefix "${boost_include_dir}"
	)
	print_variable(boost_prefix)
	#
	# add boost include directories
	FOREACH(dir ${cmake_install_includedirs})
		IF( IS_DIRECTORY ${boost_prefix}/${dir} )
			INCLUDE_DIRECTORIES( ${boost_prefix}/${dir} )
			MESSAGE(STATUS "Found ${boost_prefix}/${dir}")
		ENDIF( IS_DIRECTORY ${boost_prefix}/${dir} )
	ENDFOREACH( dir )
	#
	# add boost link directories
	FOREACH(dir ${cmake_install_libdirs})
		IF( IS_DIRECTORY ${boost_prefix}/${dir} )
			LINK_DIRECTORIES( ${boost_prefix}/${dir} )
			MESSAGE(STATUS "Found ${boost_prefix}/${dir}")
		ENDIF( IS_DIRECTORY ${boost_prefix}/${dir} )
	ENDFOREACH( dir )
ENDIF ( Boost_FOUND )
# -----------------------------------------------------------------------------
# ipopt_LIBRARIES and ipopt_LIBRARY_DIRS
IF( cppad_has_ipopt )
	FIND_PACKAGE(PkgConfig)
	IF( NOT PKG_CONFIG_FOUND )
		MESSAGE(FATAL_ERROR "Using ipopt_prefix but cannot find pkg-config")
	ENDIF( NOT PKG_CONFIG_FOUND )
	#
	# Set the system environment variable PKG_CONFIG_PATH
	FOREACH(dir ${cmake_install_libdirs})
		IF(EXISTS "${ipopt_prefix}/${dir}/pkgconfig/ipopt.pc")
			SET( ENV{PKG_CONFIG_PATH} ${ipopt_prefix}/${dir}/pkgconfig )
		ENDIF(EXISTS "${ipopt_prefix}/${dir}/pkgconfig/ipopt.pc")
	ENDFOREACH(dir)
	#
	# pkg_check_modules(<PREFIX> [REQUIRED] <MODULE> [<MODULE>]*)
	# ipopt_LIBRARIES      ... only the libraries (w/o the '-l')
	# ipopt_LIBRARY_DIRS   ... the paths of the libraries (w/o the '-L')
	pkg_check_modules(ipopt ipopt)
	IF( NOT ipopt_FOUND )
		MESSAGE(FATAL_ERROR
"For all directories dir in cmake_install_libdirs, cannot find the file
	ipopt_prefix/dir/pkgconfig/ipopt.pc
where
	ipopt_prefix = ${ipopt_prefix}
	cmake_install_libdirs = ${cmake_install_libdirs}
"
		)
	ENDIF( NOT ipopt_FOUND )
ENDIF( cppad_has_ipopt )
# =============================================================================
# Currently building tests as normal executables
# =============================================================================
# The CMakeLists.txt file in the specified source directory is processed
# before the current input file continues beyond this command.
# add_subdirectory(source_dir [binary_dir] [EXCLUDE_FROM_ALL])
#
# Initialize list of tests as empty
SET(check_depends "")
#
# directories with no check depends entries
ADD_SUBDIRECTORY(cppad)
ADD_SUBDIRECTORY(pkgconfig)
IF( cppad_has_colpack )
	ADD_SUBDIRECTORY(cppad_lib)
ENDIF( cppad_has_colpack )
#
IF( NOT ( "${check_depends}" STREQUAL "" ) )
	MESSAGE(FATAL_ERROR "Error in CMakeLists.txt scripts")
ENDIF( NOT ( "${check_depends}" STREQUAL "" ) )
#
# directories with check depends entries

=== cppad/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Configure the CppAD include file directory
# -----------------------------------------------------------------------------
# check_match
MACRO(check_match match_variable match_constant output_variable)
	STRING(COMPARE EQUAL ${${match_variable}} ${match_constant} match_flag )
	IF( match_flag )
		SET(${output_variable} 1)
	ELSE( match_flag )
		SET(${output_variable} 0)
	ENDIF( match_flag )
	print_variable(${output_variable})
ENDMACRO(check_match)
# -----------------------------------------------------------------------------
# cppad_compiler_is_gnucxx
IF( CMAKE_COMPILER_IS_GNUCXX )
	SET( cppad_compiler_is_gnucxx 1 )
ELSE( CMAKE_COMPILER_IS_GNUCXX )
	SET( cppad_compiler_is_gnucxx 0 )
ENDIF( CMAKE_COMPILER_IS_GNUCXX )
# -----------------------------------------------------------------------------
# cppad_boostvector, cppad_cppadvector, cppad_eigenvector, cppad_stdvector
#
check_match(cppad_testvector boost cppad_boostvector)
check_match(cppad_testvector cppad cppad_cppadvector)
check_match(cppad_testvector eigen cppad_eigenvector)
check_match(cppad_testvector std   cppad_stdvector)
IF( NOT cppad_boostvector )
IF( NOT cppad_cppadvector )
IF( NOT cppad_eigenvector )
IF( NOT cppad_stdvector )
MESSAGE(FATAL_ERROR
"cppad_testvector not one of following: boost, cppad, eigen, std."
)
ENDIF( NOT cppad_stdvector )
ENDIF( NOT cppad_eigenvector )
ENDIF( NOT cppad_cppadvector )
ENDIF( NOT cppad_boostvector )

IF( cppad_boostvector )
	# FIND_PACKAGE(Boost) done by ../CMakeLists.txt
	IF( NOT Boost_FOUND )
		MESSAGE(FATAL_ERROR
"cppad_testvector == boost but cannot find boost include files"
		)
	ENDIF( NOT Boost_FOUND )
ENDIF( cppad_boostvector )
#
IF( cppad_eigenvector )
	IF( NOT eigen_prefix )
		MESSAGE(FATAL_ERROR
"cppad_testvector == eigen but eigen_prefix is not specified"
		)
	ENDIF( NOT eigen_prefix )
ENDIF( cppad_eigenvector )
# =============================================================================
# Begin C++11 features
#
SET(cppad_cplusplus_201100_ok 1)
# -----------------------------------------------------------------------------
# cppad_has_signed_long_long
#
SET(source "
int main(void)
{	signed long long value = 0;
	return int(value);
}"
)
check_source_runs("${source}" cppad_has_signed_long_long )
IF( NOT cppad_has_signed_long_long )
	SET(cppad_cplusplus_201100_ok 0)
ENDIF( NOT cppad_has_signed_long_long )
# -----------------------------------------------------------------------------
# cppad_has_rvalue
#
SET(source "
int main(void)
{	int&& value = 1 + 2;
	if( value != 3 )
		return 1;
	return 0;
}"
)
check_source_runs("${source}" cppad_has_rvalue)
IF( NOT cppad_has_rvalue )
	SET(cppad_cplusplus_201100_ok 0)
ENDIF( NOT cppad_has_rvalue )
# -----------------------------------------------------------------------------
# cppad_has_nullptr
#
SET(source "
int main(void)
{	char *c = nullptr;
	return 0;
}"
)
check_source_runs("${source}" cppad_has_nullptr)
IF( NOT cppad_has_nullptr )
	SET(cppad_cplusplus_201100_ok 0)
ENDIF( NOT cppad_has_nullptr )
# -----------------------------------------------------------------------------
# cppad_has_long_long
#
SET(source "
template <class T> inline bool is_pod(void)  { return false; }
template <>  inline bool is_pod<signed long long>(void) { return true;  }
template <>  inline bool is_pod<unsigned long long>(void) { return true;  }
int main(void)
{	return 0; }
"
)
check_source_runs("${source}" cppad_has_long_long)
IF( NOT cppad_has_long_long )
	SET(cppad_cplusplus_201100_ok 0)
ENDIF( NOT cppad_has_long_long )
# -----------------------------------------------------------------------------
# cppad_compiler_has_erf
# cppad_compiler_has_asinh
# cppad_compiler_has_acosh
# cppad_compiler_has_atanh
# cppad_compiler_has_expm1
#
SET(source_template "
# include <cmath>
int main(void)
{	std::c11_function(0.0);
	return 0;
}
"
)
FOREACH(c11_function erf asinh acosh atanh expm1 log1p)
	STRING(REPLACE "c11_function" ${c11_function} source "${source_template}" )
	# really only checking if program compiles
	check_source_runs("${source}" cppad_compiler_has_${c11_function} )
	IF( NOT cppad_compiler_has_${c11_function} )
		SET(cppad_cplusplus_201100_ok 0)
	ENDIF( NOT cppad_compiler_has_${c11_function} )
ENDFOREACH(c11_function)
# -----------------------------------------------------------------------------
# cppad_has_steady_clock
#
SET(source "
# include <chrono>
# include <thread>
# include <iostream>
int main(void)
{	std::chrono::time_point<std::chrono::steady_clock> start, end;
    start = std::chrono::steady_clock::now();
	std::this_thread::sleep_for( std::chrono::milliseconds(1) );
    end   = std::chrono::steady_clock::now();
    std::chrono::duration<double> difference = end - start;
	double elapsed_seconds = difference.count();
	if( elapsed_seconds >= 0.9e-3 ) // 1e-3 = one millisecond
		return 0;
	return 1;
}
"
)
check_source_runs("${source}" cppad_has_steady_clock)
IF( NOT cppad_has_steady_clock )
	SET(cppad_cplusplus_201100_ok 0)
ENDIF( NOT cppad_has_steady_clock )
# =============================================================================
# End C++11 features
#
print_variable(cppad_cplusplus_201100_ok)
# -----------------------------------------------------------------------------
# cppad_has_gettimeofday
#
SET(source "
# include<sys/time.h>
int main(void)
{	struct timeval time;
	gettimeofday(&time, 0);
	return 0;
}"
)
check_source_runs("${source}" cppad_has_gettimeofday)
# -----------------------------------------------------------------------------
# cppad_tape_addr_type, cppad_tape_id_type
#
FOREACH(cmake_var cppad_tape_id_type cppad_tape_addr_type )
	SET(source "
# include <limits>
int main(void)
{	bool is_unsigned = ! std::numeric_limits<${${cmake_var}}>::is_signed;
	return int(! is_unsigned);
}
"
	)
	check_source_runs("${source}" ${cmake_var}_is_unsigned)
	IF( ${cmake_var}_is_unsigned STREQUAL 0  )
		MESSAGE(STATUS
"Warning: using a signed ${cmake_var} is for CppAD developers only !"
	)
	ENDIF( ${cmake_var}_is_unsigned STREQUAL 0  )
ENDFOREACH( cmake_var )
# -----------------------------------------------------------------------------
# check that cppad_max_num_threads is >= 4
#
SET(CMAKE_REQUIRED_INCLUDES  "")
SET(CMAKE_REQUIRED_LIBRARIES "")
SET(CMAKE_REQUIRED_FLAGS     )
SET(source "
int main(void)
{	const char* number = \"${cppad_max_num_threads}\";
	int value = 0;
	while( *number == ' ' )
		number++;
	while( '0' <= *number && *number <= '9' )
	{	value = 10 * value + (int)(*number - '0');
		number++;
	}
	while( *number == ' ' )
		number++;
	if( *number != char(0) )
		return 1;
	if( value < 4 )
		return 1;
	return 0;
}
" )
# Using CHECK_CXX_SOURCE_RUNS directly (instead of check_source_runs).
CHECK_CXX_SOURCE_RUNS("${source}" cppad_max_num_threads_is_integer_ge_4)
IF( NOT cppad_max_num_threads_is_integer_ge_4 )
	MESSAGE(FATAL_ERROR
	"cppad_max_num_threads is not an integer greater than or equal 4"
	)
ENDIF( NOT cppad_max_num_threads_is_integer_ge_4 )
# -----------------------------------------------------------------------------
# cppad_has_mkstemp
#
SET(source "
# include <stdlib.h>
# include <unistd.h>
int main(void)
{
	char pattern[] = \"/tmp/fileXXXXXX\";
	int fd = mkstemp(pattern);
	return 0;
}
" )
check_source_runs("${source}" cppad_has_mkstemp )
# -----------------------------------------------------------------------------
# cppad_has_tmpname_s
#
SET(source "
# include <stdio.h>
int main(void)
{	char filename[L_tmpnam_s ];
	if( tmpnam_s(filename, L_tmpnam_s ) != 0 )
		return 1;
	return 0;
}
" )
check_source_runs("${source}" cppad_has_tmpnam_s )
# -----------------------------------------------------------------------------
# configure.hpp
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/configure.hpp.in
	${CMAKE_CURRENT_SOURCE_DIR}/configure.hpp
)
# -----------------------------------------------------------------------------
# configure files in local subdirectory
ADD_SUBDIRECTORY(local)

=== cppad_ipopt/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------

# Initialize list of tests as empty
SET(check_cppad_ipopt_depends "")

# assert ipopt_prefix is defined
IF ( NOT ipopt_prefix )
	MESSAGE(FATAL_ERROR
		"cppad_ipopt/CMakeLists.txt: ipopt_prefix = ${ipopt_prefix}"
	)
ENDIF ( NOT ipopt_prefix )

# The CMakeLists.txt file in the specified source directory is processed
# before the current input file continues beyond this command.
# add_subdirectory(source_dir [binary_dir] [EXCLUDE_FROM_ALL])
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(example)
ADD_SUBDIRECTORY(speed)
ADD_SUBDIRECTORY(test)

# Add the check_cppad_ipopt target
ADD_CUSTOM_TARGET(check_cppad_ipopt DEPENDS ${check_cppad_ipopt_depends} )
MESSAGE(STATUS "make check_cppad_ipopt: available")

# Change check depends in parent environment
add_to_list(check_depends check_cppad_ipopt)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== cppad_lib/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build and install the cppad_lib shared library
#
# string(REGEX REPLACE <regular_expression>
#        <replace_expression> <output variable>
#        <input> [<input>...])
#
# (year - 2000) dot (remove leading 0 from mmdd) dot (release)
# Note that the dot (release) is optional
# Also name that when mmdd is 0000 get (year - 2000) dot dot (release)
STRING(REGEX REPLACE
	"20([0-9][0-9])0*([0-9]*)([.]?[0-9]*)"
	"\\1.\\2\\3"
	soversion
	${cppad_version}
)
# In case where mmdd is 0000, dot (release) is present. Convert to
# (year - 2000) dot 0 dot (release)
STRING(REGEX REPLACE
	"([.][.])"
	".0."
	soversion
	${soversion}
)
print_variable(soversion)
#
#  add_library(<name> [STATIC | SHARED | MODULE] [EXCLUDE_FROM_ALL]
#	source1 source2 ... sourceN)
# )
SET(source_list cppad_colpack.cpp)
set_compile_flags(cppad_lib "${cppad_debug_which}" "${source_list}" )
ADD_LIBRARY( cppad_lib SHARED ${source_list} )
#
# set_target_properties(target1 target2 ...
# PROPERTIES prop1 value1 prop2 value2 ...)
SET_TARGET_PROPERTIES( cppad_lib PROPERTIES SOVERSION ${soversion} )
#
# install(TARGETS myExe mySharedLib myStaticLib
#	RUNTIME DESTINATION bin
#	LIBRARY DESTINATION lib
#	ARCHIVE DESTINATION lib/static)
INSTALL(TARGETS cppad_lib DESTINATION ${cppad_abs_libdir})

=== example/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the example directory tests
# Inherit environment from ../CMakeList.txt

# initialize check_depends
SET(check_example_depends "")

# abs_normal examples
ADD_SUBDIRECTORY(abs_normal)

# atomic examples
ADD_SUBDIRECTORY(atomic)

# deprecated examples
ADD_SUBDIRECTORY(deprecated)

# general examples
ADD_SUBDIRECTORY(general)

# get_started
ADD_SUBDIRECTORY(get_started)

# ipopt_solve examples
IF( cppad_has_ipopt)
	ADD_SUBDIRECTORY(ipopt_solve)
ENDIF( cppad_has_ipopt)

# multi_thread examples
ADD_SUBDIRECTORY(multi_thread)

# optimize examples
ADD_SUBDIRECTORY(optimize)

# print_for example
ADD_SUBDIRECTORY(print_for)

# sparse examples
ADD_SUBDIRECTORY(sparse)

# utility examples
ADD_SUBDIRECTORY(utility)

# Add the check_example target
ADD_CUSTOM_TARGET(check_example "" DEPENDS ${check_example_depends})
MESSAGE(STATUS "make check_example: available")

# Change check depends in parent environment
add_to_list(check_depends check_example)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== introduction/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the introduction/exp_apx directory tests

SET(source_list
	introduction.cpp
	exp_2.cpp
	exp_2.hpp
	exp_2_cppad.cpp
	exp_2_for1.cpp
	exp_2_for2.cpp
	exp_2_rev1.cpp
	exp_2_rev2.cpp
	exp_2_for0.cpp
	exp_eps.cpp
	exp_eps.hpp
	exp_eps_cppad.cpp
	exp_eps_for1.cpp
	exp_eps_for2.cpp
	exp_eps_for0.cpp
	exp_eps_rev1.cpp
	exp_eps_rev2.cpp
)
set_compile_flags( introduction "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( introduction EXCLUDE_FROM_ALL ${source_list} )

# Add this check target
ADD_CUSTOM_TARGET(check_introduction
	introduction
	DEPENDS introduction
)
MESSAGE(STATUS "make check_introduction: available")

# Change check depends in parent environment
add_to_list(check_depends check_introduction)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== pkgconfig/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Construct cppad.pc from cppad.pc.in; see
# http://people.freedesktop.org/~dbn/pkg-config-guide.html
#
# Setting that are always included
SET(cppad_pkgconfig_cflags "-I${cppad_abs_includedir}")
SET(cppad_pkgconfig_libs "")
SET(cppad_pkgconfig_requires "")
#
# Settings that are only included if cppad is configured with ipopt.
# (Note that ipopt has a pkgconfig file.)
IF( cppad_has_ipopt )
	SET(cppad_pkgconfig_requires "ipopt")
	SET(cppad_pkgconfig_libs "-L${cppad_abs_libdir} -lcppad_ipopt")
ENDIF( cppad_has_ipopt )
#
# Settings that are only included if cppad is configured with colpack
# (Note that colpack does not have a pkgconfig file.)
IF( cppad_has_colpack )
	SET(cppad_pkgconfig_libs "${cppad_pkgconfig_libs} -lColPack")
	FOREACH(dir ${cmake_install_libdirs})
		IF(IS_DIRECTORY ${colpack_prefix}/${dir} )
			SET(cppad_pkgconfig_libs
				"${cppad_pkgconfig_libs} -L${colpack_prefix}/${dir}"
			)
		ENDIF(IS_DIRECTORY ${colpack_prefix}/${dir} )
	ENDFOREACH(dir)
	FOREACH(dir ${cmake_install_includedirs})
		IF(IS_DIRECTORY ${colpack_prefix}/${dir} )
			SET(cppad_pkgconfig_cflags
				"${cppad_pkgconfig_cflags} -I${colpack_prefix}/${dir}"
			)
		ENDIF(IS_DIRECTORY ${colpack_prefix}/${dir} )
	ENDFOREACH(dir)
ENDIF( cppad_has_colpack )
#
print_variable(cppad_pkgconfig_cflags)
print_variable(cppad_pkgconfig_libs)
print_variable(cppad_pkgconfig_requires)
#
# Copy a file to another location and modify its contents.
# configure_file(InputFile OutputFile [COPYONLY] [ESCAPE_QUOTES] [@ONLY])
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/cppad.pc.in
	${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
)
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/cppad-uninstalled.pc.in
	${CMAKE_CURRENT_BINARY_DIR}/cppad-uninstalled.pc
)
# During install copy cppad.pc to CMAKE_INSTALL_PREFIX/
# install(FILES files... DESTINATION <dir>
#	[PERMISSIONS permissions...]
#	[CONFIGURATIONS [Debug|Release|...]]
#	[COMPONENT <component>]
#	[RENAME <name>] [OPTIONAL])
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc DESTINATION ${cppad_abs_datadir}/pkgconfig )

=== speed/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------

# Initialize list of tests as empty
SET(check_speed_depends "")

# The CMakeLists.txt file in the specified source directory is processed
# before the current input file continues beyond this command.
# add_subdirectory(source_dir [binary_dir] [EXCLUDE_FROM_ALL])
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(cppad)
ADD_SUBDIRECTORY(double)
ADD_SUBDIRECTORY(example)
IF ( cppad_profile_flag )
	ADD_SUBDIRECTORY(profile)
ENDIF ( cppad_profile_flag )
#
IF( cppad_has_adolc )
	ADD_SUBDIRECTORY(adolc)
ENDIF( cppad_has_adolc )
IF( cppad_has_fadbad )
	ADD_SUBDIRECTORY(fadbad)
ENDIF( cppad_has_fadbad )
IF( cppad_has_sacado )
	ADD_SUBDIRECTORY(sacado)
ENDIF( cppad_has_sacado )

# check_speed
ADD_CUSTOM_TARGET(check_speed DEPENDS ${check_speed_depends} )
MESSAGE(STATUS "make check_speed: available")

# Change check depends in parent environment
add_to_list(check_depends check_speed)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== test_more/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the test_more directory tests

# initialize check_depends
SET(check_test_more_depends "")

# compare_c tests
ADD_SUBDIRECTORY(compare_c)

# debug_rel tests
ADD_SUBDIRECTORY(debug_rel)

# cppad_for_tmb tests
ADD_SUBDIRECTORY(cppad_for_tmb)

# general tests
ADD_SUBDIRECTORY(general)

# Add the check_example target
ADD_CUSTOM_TARGET(check_test_more "" DEPENDS ${check_test_more_depends})
MESSAGE(STATUS "make check_test_more: available")

# Change check depends in parent environment
add_to_list(check_depends check_test_more)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== cppad/local/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the cppad/local/is_pod.hpp file.
# -----------------------------------------------------------------------------
# is_pod_main
SET(is_pod_main "
	int main(void) { return 0; }"
)
# is_pod_default
SET(is_pod_default
	"template <class T> inline bool is_pod(void) { return false; }"
)
# -----------------------------------------------------------------------------
# is_pod_specialize_98
SET(is_pod_specialize_98 "")
SET(pod_type_list "bool" "float" "double" "long double")
FOREACH(base_type "char" "short" "int" "long" )
	FOREACH(sign signed unsigned)
		add_to_list(pod_type_list "${sign} ${base_type}")
	ENDFOREACH(sign signed unsigned)
ENDFOREACH(base_type)
#
FOREACH(pod_type ${pod_type_list})
	STRING(REPLACE " " "_" pod_type_var "${pod_type}")
	SET(pod_type_var "pod_type_${pod_type_var}")
	SET(line "
	template <> inline bool is_pod<${pod_type}>(void) { return true; }"
	)
	SET(source
		"${is_pod_default} ${is_pod_specialize_98} ${line} ${is_pod_main}"
	)
	CHECK_CXX_SOURCE_RUNS("${source}" ${pod_type_var} )
	IF( ${pod_type_var} )
		SET(is_pod_specialize_98 "${is_pod_specialize_98}${line}")
	ENDIF( ${pod_type_var} )
ENDFOREACH(pod_type)
# -----------------------------------------------------------------------------
# is_pod_specialize_11
SET(is_pod_specialize_11 "")
SET(pod_type_list "")
FOREACH(base_type "long long" )
	FOREACH(sign signed unsigned)
		add_to_list(pod_type_list "${sign} ${base_type}")
	ENDFOREACH(sign signed unsigned)
ENDFOREACH(base_type)
#
FOREACH(pod_type ${pod_type_list})
	STRING(REPLACE " " "_" pod_type_var "${pod_type}")
	SET(pod_type_var "pod_type_${pod_type_var}")
	SET(line "
	template <> inline bool is_pod<${pod_type}>(void) { return true; }"
	)
	SET(source
		"${is_pod_default} ${is_pod_specialize_98} ${is_pod_specialize_11}
		${line} ${is_pod_main}"
	)
	CHECK_CXX_SOURCE_RUNS("${source}" ${pod_type_var} )
	IF( ${pod_type_var} )
		SET(is_pod_specialize_11 "${is_pod_specialize_11}${line}")
	ENDIF( ${pod_type_var} )
ENDFOREACH(pod_type)
# -----------------------------------------------------------------------------
# is_pod.hpp
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/is_pod.hpp.in
	${CMAKE_CURRENT_SOURCE_DIR}/is_pod.hpp
)

=== cppad_ipopt/example/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Inherit build type from ../CMakeList.txt

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# Local link directories to search (not in external packages)
LINK_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR}/../src ${ipopt_LIBRARY_DIRS} )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
SET(source_list
	example.cpp
	get_started.cpp
	ode_check.cpp
	ode_check.hpp
	ode_fast_check.cpp
	ode_fast.hpp
	ode_problem.hpp
	ode_run.hpp
	ode_simple_check.cpp
	ode_simple.hpp
)
set_compile_flags( cppad_ipopt_example "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( cppad_ipopt_example EXCLUDE_FROM_ALL ${source_list} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(cppad_ipopt_example
	cppad_ipopt
	${cppad_lib}
	${ipopt_LIBRARIES}
	${colpack_libs}
)

# Add the check_cppad_ipopt_example target
ADD_CUSTOM_TARGET(check_cppad_ipopt_example
	cppad_ipopt_example
	DEPENDS cppad_ipopt_example cppad_ipopt
)
MESSAGE(STATUS "make check_cppad_ipopt_example: available")

# Change check depends in parent environment
add_to_list(check_cppad_ipopt_depends check_cppad_ipopt_example)
SET(check_cppad_ipopt_depends "${check_cppad_ipopt_depends}" PARENT_SCOPE)

=== cppad_ipopt/speed/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under multiple licenses. This distribution is under
# the terms of the
#                     GNU General Public License Version 3.
#
# A copy of this license is included in the COPYING file of this distribution.
# Please visit http://www.coin-or.org/CppAD/ for information on other licenses.
# -----------------------------------------------------------------------------
# Build the cppad_ipopt/speed directory tests
# Inherit build type from ../CMakeList.txt

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# Local link directories to search (not in external packages)
# (cannot use ../src/cppad_ipopt library because it is linke with debugging)
LINK_DIRECTORIES( ${ipopt_LIBRARY_DIRS} )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
# Include source for cppad_ipopt library so we build it without debugging
SET(source_list
	speed.cpp
	../src/cppad_ipopt_nlp.cpp
	../src/fun_record.hpp
	../src/hes_fg_map.cpp
	../src/jac_g_map.cpp
	../src/sparse_map2vec.cpp
	../src/vec_fun_pattern.cpp
	ode_speed.cpp
)
set_compile_flags( cppad_ipopt_speed "debug_none" "${source_list}" )
#
ADD_EXECUTABLE( cppad_ipopt_speed EXCLUDE_FROM_ALL ${source_list} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(
	cppad_ipopt_speed
	cppad_ipopt
	${cppad_lib}
	${ipopt_LIBRARIES}
	${colpack_libs}
)

# Add the check_cppad_ipopt_speed target
ADD_CUSTOM_TARGET(check_cppad_ipopt_speed
	cppad_ipopt_speed
	DEPENDS cppad_ipopt_speed cppad_ipopt
)
MESSAGE(STATUS "make check_cppad_ipopt_speed: available")

# Change check depends in parent environment
add_to_list(check_cppad_ipopt_depends check_cppad_ipopt_speed)
SET(check_cppad_ipopt_depends "${check_cppad_ipopt_depends}" PARENT_SCOPE)

=== debian/changelog ===
cppad (2018.00.00.0-1) unstable; urgency=medium

  * New upstream release
  * Bump policy
  * Bump to debhelper 11
  * Can install nonexistent NEWS file, install not README but readme.md

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 09 Jan 2018 16:10:12 +0000

=== debian/control ===
Source: cppad
Section: devel
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Miles Lubin <miles.lubin@gmail.com>,
           Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper (>= 11), cmake, libboost-dev
Standards-Version: 4.1.3
Homepage: https://projects.coin-or.org/CppAD/
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/cppad.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=debian-science/packages/cppad.git

Package: cppad
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Automatic Differentiation (AD) of C++ algorithms
 CppAD is a package for automatic differentiation of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains C++ header files and documentation.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_autoreconf:
	@echo "Hey, debhelper 10, what the heck are you doing?"
	@echo "Stop!"
	@echo "Stop it!!"
	@echo "THE BUILD SYSTEM IS CMAKE!!!"

# web documentation uses .xml extension
override_dh_compress:
	dh_compress -X.xml

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog-upstream

override_dh_link:
	cd debian/cppad/usr/share/doc/cppad/doc && \
	if test -e cppad.xml -a \! -e index.xml \
	   || cmp cppad.xml index.xml ; then \
	  echo index.xml missing or identical to cppad.xml && \
	  ln --verbose --symbolic --force cppad.xml index.xml ; \
	fi
	dh_link

=== debian/watch ===
# See uscan(1) for format
version=4

# Snapshot tarballs?
http://www.coin-or.org/download/source/CppAD/ \
 cppad-(\d\d\d\d)(\d\d)(\d\d)\.(\d+).gpl.tgz
